#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <boolean.h>
#include <scanner.h>
#include "cs2parse.h"
#include "cs2ptoken.h"


#define PARSER_PARAGRAPH_STRING_LOK            "lok"
#define PARSER_PARAGRAPH_STRING_NUMLOKS        "numloks"
#define PARSER_PARAGRAPH_STRING_LOKOMOTIVE     "lokomotive"
#define PARSER_PARAGRAPH_STRING_GERAET         "geraet"
#define PARSER_PARAGRAPH_STRING_GLEISBILD      "gleisbild"
#define PARSER_PARAGRAPH_STRING_MAGNETARTIKEL  "magnetartikel"
#define PARSER_PARAGRAPH_STRING_FAHRSTRASSEN   "fahrstrassen"
#define PARSER_PARAGRAPH_STRING_GLEISBILDSEITE "gleisbildseite"
#define PARSER_PARAGRAPH_STRING_LOKSTATUS      "lokstatus"
#define PARSER_VALUE_STRING_VERSION           "version"
#define PARSER_VALUE_STRING_NAME              "name"
#define PARSER_VALUE_STRING_WERT              "wert"
#define PARSER_VALUE_STRING_LOK               "lok"
#define PARSER_VALUE_STRING_UID               "uid"
#define PARSER_VALUE_STRING_ADRESSE           "adresse"
#define PARSER_VALUE_STRING_TYP               "typ"
#define PARSER_VALUE_STRING_MFXUID            "mfxuid"
#define PARSER_VALUE_STRING_SYMBOL            "symbol"
#define PARSER_VALUE_STRING_AV                "av"
#define PARSER_VALUE_STRING_BV                "bv"
#define PARSER_VALUE_STRING_VOLUME            "volume"
#define PARSER_VALUE_STRING_VELOCITY          "velocity"
#define PARSER_VALUE_STRING_RICHTUNG          "richtung"
#define PARSER_VALUE_STRING_VMAX              "vmax"
#define PARSER_VALUE_STRING_VMIN              "vmin"
#define PARSER_VALUE_STRING_FKT               "fkt"
#define PARSER_VALUE_STRING_DAUER             "dauer"
#define PARSER_VALUE_STRING_VERSION           "version"
#define PARSER_VALUE_STRING_MINOR             "minor"
#define PARSER_VALUE_STRING_SERNUM            "sernum"
#define PARSER_VALUE_STRING_GFPUID            "gfpuid"
#define PARSER_VALUE_STRING_GUIUID            "guiuid"
#define PARSER_VALUE_STRING_HARDVERS          "hardvers"
#define PARSER_VALUE_STRING_MAJOR             "major"
#define PARSER_VALUE_STRING_SESSION           "session"
#define PARSER_VALUE_STRING_ID                "id"
#define PARSER_VALUE_STRING_SID               "sid"
#define PARSER_VALUE_STRING_ICON              "icon"
#define PARSER_VALUE_STRING_TACHOMAX          "tachomax"
#define PARSER_VALUE_STRING_XPROTOKOLL        "xprotokoll"
#define PARSER_VALUE_STRING_MFXTYP            "mfxtyp"
#define PARSER_VALUE_STRING_STAND             "stand"
#define PARSER_VALUE_STRING_FAHRT             "fahrt"
#define PARSER_VALUE_STRING_FUNKTIONEN        "funktionen"
#define PARSER_VALUE_STRING_NR                "nr"
#define PARSER_VALUE_STRING_VORWAERTS         "vorwaerts"
#define PARSER_VALUE_STRING_RUECKWAERTS       "rueckwaerts"
#define PARSER_VALUE_STRING_INTRAKTION        "inTraktion"
#define PARSER_VALUE_STRING_SEITE             "seite"
#define PARSER_VALUE_STRING_GROESSE           "groesse"
#define PARSER_VALUE_STRING_ZULETZT_BENUTZT   "zuletztBenutzt"
#define PARSER_VALUE_STRING_ARTIKEL           "artikel"
#define PARSER_VALUE_STRING_STELLUNG          "stellung"
#define PARSER_VALUE_STRING_SCHALTZEIT        "schaltzeit"
#define PARSER_VALUE_STRING_UNGERADE          "ungerade"
#define PARSER_VALUE_STRING_DECODER           "decoder"
#define PARSER_VALUE_STRING_DECTYP            "dectyp"
#define PARSER_VALUE_STRING_FAHRSTRASSE       "fahrstrasse"
#define PARSER_VALUE_STRING_S88               "s88"
#define PARSER_VALUE_STRING_S88EIN            "s88Ein"
#define PARSER_VALUE_STRING_EXTERN            "extern"
#define PARSER_VALUE_STRING_ITEM              "item"
#define PARSER_VALUE_STRING_FSVERWEIS         "fsverweis"
#define PARSER_VALUE_STRING_ELEMENT           "element"
#define PARSER_VALUE_STRING_DREHUNG           "drehung"
#define PARSER_VALUE_STRING_ARTIKEL           "artikel"
#define PARSER_VALUE_STRING_TEXT              "text"
#define PARSER_VALUE_STRING_ZUSTAND           "zustand"
#define PARSER_VALUE_STRING_DEVICE_ID         "deviceId"
#define PARSER_VALUE_STRING_PAGE              "page"
#define PARSER_VALUE_STRING_SEKUNDE           "sekunde"
#define PARSER_VALUE_STRING_IDX               "idx"
#define PARSER_VALUE_STRING_ON                "on"

ScanKeyword LokNameKeywords[] = {
   { PARSER_PARAGRAPH_STRING_LOK,     PARSER_TOKEN_KEYWORD_LOK },
   { PARSER_PARAGRAPH_STRING_NUMLOKS, PARSER_TOKEN_KEYWORD_NUMLOKS },
   { PARSER_VALUE_STRING_NAME,        PARSER_TOKEN_KEYWORD_NAME },
   { PARSER_VALUE_STRING_WERT,        PARSER_TOKEN_KEYWORD_WERT },
};

ScanKeyword LokInfoKeywords[] = {
   { PARSER_PARAGRAPH_STRING_LOKOMOTIVE, PARSER_TOKEN_KEYWORD_LOKOMOTIVE },
   { PARSER_VALUE_STRING_LOK,            PARSER_TOKEN_KEYWORD_LOK },
   { PARSER_VALUE_STRING_NAME,           PARSER_TOKEN_KEYWORD_NAME },
   { PARSER_VALUE_STRING_WERT,           PARSER_TOKEN_KEYWORD_WERT },
   { PARSER_VALUE_STRING_UID,            PARSER_TOKEN_KEYWORD_UID },
   { PARSER_VALUE_STRING_ADRESSE,        PARSER_TOKEN_KEYWORD_ADRESSE },
   { PARSER_VALUE_STRING_TYP,            PARSER_TOKEN_KEYWORD_TYP },
   { PARSER_VALUE_STRING_MFXUID,         PARSER_TOKEN_KEYWORD_MFXUID },
   { PARSER_VALUE_STRING_SYMBOL,         PARSER_TOKEN_KEYWORD_SYMBOL },
   { PARSER_VALUE_STRING_AV,             PARSER_TOKEN_KEYWORD_AV },
   { PARSER_VALUE_STRING_BV,             PARSER_TOKEN_KEYWORD_BV },
   { PARSER_VALUE_STRING_VOLUME,         PARSER_TOKEN_KEYWORD_VOLUME },
   { PARSER_VALUE_STRING_VELOCITY,       PARSER_TOKEN_KEYWORD_VELOCITY },
   { PARSER_VALUE_STRING_RICHTUNG,       PARSER_TOKEN_KEYWORD_RICHTUNG },
   { PARSER_VALUE_STRING_VMAX,           PARSER_TOKEN_KEYWORD_VMAX },
   { PARSER_VALUE_STRING_VMIN,           PARSER_TOKEN_KEYWORD_VMIN },
   { PARSER_VALUE_STRING_FKT,            PARSER_TOKEN_KEYWORD_FKT },
   { PARSER_VALUE_STRING_DAUER,          PARSER_TOKEN_KEYWORD_DAUER },
};

ScanKeyword GeraetVrsKeywords[] = {
   { PARSER_PARAGRAPH_STRING_GERAET, PARSER_TOKEN_KEYWORD_GERAET },
   { PARSER_VALUE_STRING_VERSION,    PARSER_TOKEN_KEYWORD_VERSION },
   { PARSER_VALUE_STRING_MINOR,      PARSER_TOKEN_KEYWORD_MINOR },
   { PARSER_VALUE_STRING_MAJOR,      PARSER_TOKEN_KEYWORD_MAJOR },
   { PARSER_VALUE_STRING_SERNUM,     PARSER_TOKEN_KEYWORD_SERNUM },
   { PARSER_VALUE_STRING_GFPUID,     PARSER_TOKEN_KEYWORD_GFPUID },
   { PARSER_VALUE_STRING_GUIUID,     PARSER_TOKEN_KEYWORD_GUIUID },
   { PARSER_VALUE_STRING_HARDVERS,   PARSER_TOKEN_KEYWORD_HARDVERS },
};

ScanKeyword LokCs2Keywords[] = {
   { PARSER_PARAGRAPH_STRING_LOKOMOTIVE, PARSER_TOKEN_KEYWORD_LOKOMOTIVE },
   { PARSER_VALUE_STRING_VERSION,        PARSER_TOKEN_KEYWORD_VERSION },
   { PARSER_VALUE_STRING_LOK,            PARSER_TOKEN_KEYWORD_LOK },
   { PARSER_VALUE_STRING_NAME,           PARSER_TOKEN_KEYWORD_NAME },
   { PARSER_VALUE_STRING_WERT,           PARSER_TOKEN_KEYWORD_WERT },
   { PARSER_VALUE_STRING_UID,            PARSER_TOKEN_KEYWORD_UID },
   { PARSER_VALUE_STRING_ADRESSE,        PARSER_TOKEN_KEYWORD_ADRESSE },
   { PARSER_VALUE_STRING_TYP,            PARSER_TOKEN_KEYWORD_TYP },
   { PARSER_VALUE_STRING_MFXUID,         PARSER_TOKEN_KEYWORD_MFXUID },
   { PARSER_VALUE_STRING_SYMBOL,         PARSER_TOKEN_KEYWORD_SYMBOL },
   { PARSER_VALUE_STRING_AV,             PARSER_TOKEN_KEYWORD_AV },
   { PARSER_VALUE_STRING_BV,             PARSER_TOKEN_KEYWORD_BV },
   { PARSER_VALUE_STRING_VOLUME,         PARSER_TOKEN_KEYWORD_VOLUME },
   { PARSER_VALUE_STRING_VELOCITY,       PARSER_TOKEN_KEYWORD_VELOCITY },
   { PARSER_VALUE_STRING_RICHTUNG,       PARSER_TOKEN_KEYWORD_RICHTUNG },
   { PARSER_VALUE_STRING_VMAX,           PARSER_TOKEN_KEYWORD_VMAX },
   { PARSER_VALUE_STRING_VMIN,           PARSER_TOKEN_KEYWORD_VMIN },
   { PARSER_VALUE_STRING_FKT,            PARSER_TOKEN_KEYWORD_FKT },
   { PARSER_VALUE_STRING_DAUER,          PARSER_TOKEN_KEYWORD_DAUER },
   { PARSER_VALUE_STRING_MINOR,          PARSER_TOKEN_KEYWORD_MINOR },
   { PARSER_VALUE_STRING_MAJOR,          PARSER_TOKEN_KEYWORD_MAJOR },
   { PARSER_VALUE_STRING_SESSION,        PARSER_TOKEN_KEYWORD_SESSION },
   { PARSER_VALUE_STRING_ID,             PARSER_TOKEN_KEYWORD_ID },
   { PARSER_VALUE_STRING_SID,            PARSER_TOKEN_KEYWORD_SID },
   { PARSER_VALUE_STRING_ICON,           PARSER_TOKEN_KEYWORD_ICON },
   { PARSER_VALUE_STRING_TACHOMAX,       PARSER_TOKEN_KEYWORD_TACHOMAX },
   { PARSER_VALUE_STRING_XPROTOKOLL,     PARSER_TOKEN_KEYWORD_XPROTOKOLL },
   { PARSER_VALUE_STRING_MFXTYP,         PARSER_TOKEN_KEYWORD_MFXTYP },
   { PARSER_VALUE_STRING_STAND,          PARSER_TOKEN_KEYWORD_STAND },
   { PARSER_VALUE_STRING_FAHRT,          PARSER_TOKEN_KEYWORD_FAHRT },
   { PARSER_VALUE_STRING_FUNKTIONEN,     PARSER_TOKEN_KEYWORD_FUNKTIONEN },
   { PARSER_VALUE_STRING_NR,             PARSER_TOKEN_KEYWORD_NR },
   { PARSER_VALUE_STRING_VORWAERTS,      PARSER_TOKEN_KEYWORD_VORWAERTS },
   { PARSER_VALUE_STRING_RUECKWAERTS,    PARSER_TOKEN_KEYWORD_RUECKWAERTS },
   { PARSER_VALUE_STRING_INTRAKTION,     PARSER_TOKEN_KEYWORD_INTRAKTION },
};

ScanKeyword GleisbildCs2Keywords[] = {
   { PARSER_PARAGRAPH_STRING_GLEISBILD,   PARSER_TOKEN_KEYWORD_GLEISBILD },
   { PARSER_VALUE_STRING_VERSION,         PARSER_TOKEN_KEYWORD_VERSION },
   { PARSER_VALUE_STRING_MINOR,           PARSER_TOKEN_KEYWORD_MINOR },
   { PARSER_VALUE_STRING_MAJOR,           PARSER_TOKEN_KEYWORD_MAJOR },
   { PARSER_VALUE_STRING_SEITE,           PARSER_TOKEN_KEYWORD_SEITE },
   { PARSER_VALUE_STRING_ID,              PARSER_TOKEN_KEYWORD_ID },
   { PARSER_VALUE_STRING_NAME,            PARSER_TOKEN_KEYWORD_NAME },
   { PARSER_VALUE_STRING_GROESSE,         PARSER_TOKEN_KEYWORD_GROESSE },
   { PARSER_VALUE_STRING_ZULETZT_BENUTZT, PARSER_TOKEN_KEYWORD_ZULETZT_BENUTZT },
   { PARSER_VALUE_STRING_ELEMENT,         PARSER_TOKEN_KEYWORD_ELEMENT },
   { PARSER_VALUE_STRING_ZUSTAND,         PARSER_TOKEN_KEYWORD_ZUSTAND },
};

ScanKeyword MagnetartikelCs2Keywords[] = {
   { PARSER_PARAGRAPH_STRING_MAGNETARTIKEL, PARSER_TOKEN_KEYWORD_MAGNETARTIKEL },
   { PARSER_VALUE_STRING_VERSION,           PARSER_TOKEN_KEYWORD_VERSION },
   { PARSER_VALUE_STRING_MINOR,             PARSER_TOKEN_KEYWORD_MINOR },
   { PARSER_VALUE_STRING_MAJOR,             PARSER_TOKEN_KEYWORD_MAJOR },
   { PARSER_VALUE_STRING_ARTIKEL,           PARSER_TOKEN_KEYWORD_ARTIKEL },
   { PARSER_VALUE_STRING_ID,                PARSER_TOKEN_KEYWORD_ID },
   { PARSER_VALUE_STRING_NAME,              PARSER_TOKEN_KEYWORD_NAME },
   { PARSER_VALUE_STRING_TYP,               PARSER_TOKEN_KEYWORD_TYP },
   { PARSER_VALUE_STRING_STELLUNG,          PARSER_TOKEN_KEYWORD_STELLUNG },
   { PARSER_VALUE_STRING_SCHALTZEIT,        PARSER_TOKEN_KEYWORD_SCHALTZEIT },
   { PARSER_VALUE_STRING_UNGERADE,          PARSER_TOKEN_KEYWORD_UNGERADE },
   { PARSER_VALUE_STRING_DECODER,           PARSER_TOKEN_KEYWORD_DECODER },
   { PARSER_VALUE_STRING_DECTYP,            PARSER_TOKEN_KEYWORD_DECTYP },
};

ScanKeyword FahrstrassenCs2Keywords[] = {
   { PARSER_PARAGRAPH_STRING_FAHRSTRASSEN,  PARSER_TOKEN_KEYWORD_FAHRSTRASSEN },
   { PARSER_VALUE_STRING_VERSION,           PARSER_TOKEN_KEYWORD_VERSION },
   { PARSER_VALUE_STRING_MINOR,             PARSER_TOKEN_KEYWORD_MINOR },
   { PARSER_VALUE_STRING_MAJOR,             PARSER_TOKEN_KEYWORD_MAJOR },
   { PARSER_VALUE_STRING_FAHRSTRASSE,       PARSER_TOKEN_KEYWORD_FAHRSTRASSE },
   { PARSER_VALUE_STRING_ID,                PARSER_TOKEN_KEYWORD_ID },
   { PARSER_VALUE_STRING_NAME,              PARSER_TOKEN_KEYWORD_NAME },
   { PARSER_VALUE_STRING_S88,               PARSER_TOKEN_KEYWORD_S88 },
   { PARSER_VALUE_STRING_S88EIN,            PARSER_TOKEN_KEYWORD_S88EIN },
   { PARSER_VALUE_STRING_EXTERN,            PARSER_TOKEN_KEYWORD_EXTERN },
   { PARSER_VALUE_STRING_ITEM,              PARSER_TOKEN_KEYWORD_ITEM },
   { PARSER_VALUE_STRING_FSVERWEIS,         PARSER_TOKEN_KEYWORD_FSVERWEIS },
   { PARSER_PARAGRAPH_STRING_MAGNETARTIKEL, PARSER_TOKEN_KEYWORD_MAGNETARTIKEL },
   { PARSER_VALUE_STRING_TYP,               PARSER_TOKEN_KEYWORD_TYP },
   { PARSER_VALUE_STRING_STELLUNG,          PARSER_TOKEN_KEYWORD_STELLUNG },
   { PARSER_VALUE_STRING_LOK,               PARSER_TOKEN_KEYWORD_LOK },
   { PARSER_VALUE_STRING_SEKUNDE,           PARSER_TOKEN_KEYWORD_SEKUNDE },
   { PARSER_VALUE_STRING_IDX,               PARSER_TOKEN_KEYWORD_IDX },
   { PARSER_VALUE_STRING_WERT,              PARSER_TOKEN_KEYWORD_WERT },
   { PARSER_VALUE_STRING_ON,                PARSER_TOKEN_KEYWORD_ON },
};

ScanKeyword GleisbildPageCs2Keywords[] = {
   { PARSER_PARAGRAPH_STRING_GLEISBILDSEITE, PARSER_TOKEN_KEYWORD_GLEISBILDSEITE },
   { PARSER_VALUE_STRING_VERSION,            PARSER_TOKEN_KEYWORD_VERSION },
   { PARSER_VALUE_STRING_MINOR,              PARSER_TOKEN_KEYWORD_MINOR },
   { PARSER_VALUE_STRING_MAJOR,              PARSER_TOKEN_KEYWORD_MAJOR },
   { PARSER_VALUE_STRING_ELEMENT,            PARSER_TOKEN_KEYWORD_ELEMENT },
   { PARSER_VALUE_STRING_ID,                 PARSER_TOKEN_KEYWORD_ID },
   { PARSER_VALUE_STRING_TYP,                PARSER_TOKEN_KEYWORD_TYP },
   { PARSER_VALUE_STRING_DREHUNG,            PARSER_TOKEN_KEYWORD_DREHUNG },
   { PARSER_VALUE_STRING_ARTIKEL,            PARSER_TOKEN_KEYWORD_ARTIKEL },
   { PARSER_VALUE_STRING_TEXT,               PARSER_TOKEN_KEYWORD_TEXT },
   { PARSER_VALUE_STRING_ZUSTAND,            PARSER_TOKEN_KEYWORD_ZUSTAND },
   { PARSER_VALUE_STRING_DEVICE_ID,          PARSER_TOKEN_KEYWORD_DEVICE_ID },
   { PARSER_VALUE_STRING_PAGE,               PARSER_TOKEN_KEYWORD_PAGE },
};

ScanKeyword HeaderCs2Keywords[] = {
   { PARSER_PARAGRAPH_STRING_LOKOMOTIVE,     PARSER_TOKEN_KEYWORD_LOKOMOTIVE },
   { PARSER_PARAGRAPH_STRING_GLEISBILD,      PARSER_TOKEN_KEYWORD_GLEISBILD },
   { PARSER_PARAGRAPH_STRING_MAGNETARTIKEL,  PARSER_TOKEN_KEYWORD_MAGNETARTIKEL },
   { PARSER_PARAGRAPH_STRING_FAHRSTRASSEN,   PARSER_TOKEN_KEYWORD_FAHRSTRASSEN },
   { PARSER_PARAGRAPH_STRING_GLEISBILDSEITE, PARSER_TOKEN_KEYWORD_GLEISBILDSEITE },
   { PARSER_PARAGRAPH_STRING_LOKSTATUS,      PARSER_TOKEN_KEYWORD_LOKSTATUS },
   { PARSER_PARAGRAPH_STRING_LOK,            PARSER_TOKEN_KEYWORD_LOK },
   { PARSER_PARAGRAPH_STRING_NUMLOKS,        PARSER_TOKEN_KEYWORD_NUMLOKS },
};

void Cs2pInit(Cs2parser *Data, int Type, char *InputLine, int Len)
{
   Cs2pSetVerbose(Data, FALSE);
   if (Type == PARSER_TYPE_LOKNAMEN)
   {
      ScanInit(Cs2pGetScanner(Data), (char *)NULL, InputLine, Len,
               4, LokNameKeywords);
   }
   else if (Type == PARSER_TYPE_LOKINFO)
   {
      ScanInit(Cs2pGetScanner(Data), (char *)NULL, InputLine, Len,
               18, LokInfoKeywords);
   }
   else if (Type == PARSER_TYPE_GERAET_VRS)
   {
      ScanInit(Cs2pGetScanner(Data), (char *)NULL, InputLine, Len,
               8, GeraetVrsKeywords);
   }
   else if (Type == PARSER_TYPE_LOK_CS2)
   {
      ScanInit(Cs2pGetScanner(Data), (char *)NULL, InputLine, Len,
               35, LokCs2Keywords);
   }
   else if (Type == PARSER_TYPE_GLEISBILD_CS2)
   {
      ScanInit(Cs2pGetScanner(Data), (char *)NULL, InputLine, Len,
               11, GleisbildCs2Keywords);
   }
   else if (Type == PARSER_TYPE_MAGNETARTIKEL_CS2)
   {
      ScanInit(Cs2pGetScanner(Data), (char *)NULL, InputLine, Len,
               13, MagnetartikelCs2Keywords);
   }
   else if (Type == PARSER_TYPE_FAHRSTRASSEN_CS2)
   {
      ScanInit(Cs2pGetScanner(Data), (char *)NULL, InputLine, Len,
               20, FahrstrassenCs2Keywords);
   }
   else if (Type == PARSER_TYPE_GLEISBILD_SEITE)
   {
      ScanInit(Cs2pGetScanner(Data), (char *)NULL, InputLine, Len,
               13, GleisbildPageCs2Keywords);
   }
   else if (Type == PARSER_TYPE_HEADER_CS2)
   {
      ScanInit(Cs2pGetScanner(Data), (char *)NULL, InputLine, Len,
               8, HeaderCs2Keywords);
   }
}
